package org.xdoclet.plugin.beaninfo.qtags;

public class JavabeanPropertyTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.beaninfo.qtags.JavabeanPropertyTag {
    public static final String NAME = "javabean.property";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"name",
		"display-name",
		"short-description",
		"expert",
		"hidden",
		"preferred",
		"default",
		"bound",
		"constrained",
		"editor",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public JavabeanPropertyTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractBaseJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public JavabeanPropertyTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractBaseJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.String getName_() {
		boolean required = false;
        String result = getNamedParameter("name");
        if(required && result == null) {
            bomb("name=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDisplayName() {
		boolean required = false;
        String result = getNamedParameter("display-name");
        if(required && result == null) {
            bomb("display-name=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getShortDescription() {
		boolean required = false;
        String result = getNamedParameter("short-description");
        if(required && result == null) {
            bomb("short-description=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public boolean isExpert() {
		boolean required = false;
        String result = getNamedParameter("expert");
        if(required && result == null) {
            bomb("expert=\"???\" must be specified.");
        }

		boolean retVal = false;


		if (result != null) {
	            if( !(false || result.equals("true")|| result.equals("false")) ) {
	                // todo we should say what file and line number too
	                bomb("expert=\"" + result + "\" is an invalid parameter value.");
	            }
		        retVal = Boolean.valueOf(result).booleanValue();
		}
		
		return retVal;
    }
    public boolean isHidden() {
		boolean required = false;
        String result = getNamedParameter("hidden");
        if(required && result == null) {
            bomb("hidden=\"???\" must be specified.");
        }

		boolean retVal = false;


		if (result != null) {
	            if( !(false || result.equals("true")|| result.equals("false")) ) {
	                // todo we should say what file and line number too
	                bomb("hidden=\"" + result + "\" is an invalid parameter value.");
	            }
		        retVal = Boolean.valueOf(result).booleanValue();
		}
		
		return retVal;
    }
    public boolean isPreferred() {
		boolean required = false;
        String result = getNamedParameter("preferred");
        if(required && result == null) {
            bomb("preferred=\"???\" must be specified.");
        }

		boolean retVal = false;


		if (result != null) {
	            if( !(false || result.equals("true")|| result.equals("false")) ) {
	                // todo we should say what file and line number too
	                bomb("preferred=\"" + result + "\" is an invalid parameter value.");
	            }
		        retVal = Boolean.valueOf(result).booleanValue();
		}
		
		return retVal;
    }
    public boolean isDefault() {
		boolean required = false;
        String result = getNamedParameter("default");
        if(required && result == null) {
            bomb("default=\"???\" must be specified.");
        }

		boolean retVal = false;


		if (result != null) {
	            if( !(false || result.equals("true")|| result.equals("false")) ) {
	                // todo we should say what file and line number too
	                bomb("default=\"" + result + "\" is an invalid parameter value.");
	            }
		        retVal = Boolean.valueOf(result).booleanValue();
		}
		
		return retVal;
    }
    public boolean isBound() {
		boolean required = false;
        String result = getNamedParameter("bound");
        if(required && result == null) {
            bomb("bound=\"???\" must be specified.");
        }

		boolean retVal = false;


		if (result != null) {
	            if( !(false || result.equals("true")|| result.equals("false")) ) {
	                // todo we should say what file and line number too
	                bomb("bound=\"" + result + "\" is an invalid parameter value.");
	            }
		        retVal = Boolean.valueOf(result).booleanValue();
		}
		
		return retVal;
    }
    public boolean isConstrained() {
		boolean required = false;
        String result = getNamedParameter("constrained");
        if(required && result == null) {
            bomb("constrained=\"???\" must be specified.");
        }

		boolean retVal = false;


		if (result != null) {
	            if( !(false || result.equals("true")|| result.equals("false")) ) {
	                // todo we should say what file and line number too
	                bomb("constrained=\"" + result + "\" is an invalid parameter value.");
	            }
		        retVal = Boolean.valueOf(result).booleanValue();
		}
		
		return retVal;
    }
    public java.lang.String getEditor() {
		boolean required = false;
        String result = getNamedParameter("editor");
        if(required && result == null) {
            bomb("editor=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }

    protected void validateLocation() {
        
        // check uniqueness

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getName_();
        getDisplayName();
        getShortDescription();
        isExpert();
        isHidden();
        isPreferred();
        isDefault();
        isBound();
        isConstrained();
        getEditor();
    }

    public void validateModel() {
        // check uniqueness
    }
}